Baudrate        equ 62500

_1000HZ_TIMER   set 7

                path "e:\bll\"
* Macros
                path "macros"
                isyms "hardware.sym"

                include "help.mac"
                include "if_while.mac"
                include "font.mac"
                include "window.mac"
                include "mikey.mac"
                include "suzy.mac"
                include "irq.mac"
                include "key.mac"
                include "debug.mac"
                include "file.mac"
* Variablen
                path "..\vardefs\"
                include "debug.var"
                include "help.var"
                include "font.var"
                include "window.var"
                include "mikey.var"
                include "suzy.var"
                include "irq.var"
                include "key.var"
                include "file.var"
                include "serial.var"
                include "1000Hz.var"
                include "EEPROM.VAR"


BEGIN_ZP
lauf            ds 1
counter         ds 1
adresse         ds 1
END_ZP

BEGIN_MEM
screen0         ds SCREEN.LEN
irq_vektoren    ds 16

eeprom          ds 128
DefaultSaveGame ds 128
END_MEM
                run LOMEM

Start::         sei
                CLEAR_MEM
                CLEAR_ZP
                INITMIKEY
                INITSUZY
                SETRGB pal
                INITIRQ irq_vektoren
                INITKEY
                INITFONT LITTLEFNT,ROT,WEISS
                jsr Init1000Hz
                jsr InitComLynx
                cli
                SCRBASE screen0
                CLS #0
                SET_MINMAX 0,0,160,102
                LDAY hallo
                jsr print
.loop00         jsr ReadKey
                beq .cont0
                lda Button
                cmp #_FIREA
                bne .cont
                ldx #127
.1              stz eeprom,x
                dex
                bpl .1
                LDAY eeprom
                jsr WriteSaveGame
                bra .cont0
.cont           cmp #_FIREB
                bne .cont0
                jsr FillEEPROM

.cont0          stz CurrX
                lda #6
                sta CurrY
                lda counter
                inc counter
                jsr PrintHex
                stz CurrX
                lda #12
                sta CurrY
                stz adresse
                stz temp
                stz temp+1
                ldx #8
.loop01          phx
                 ldx #8
.loop02           phx
                  lda adresse
                  jsr EE_Read
                  inc adresse
                  lda I2Cword
                  jsr PrintHex
                  lda I2Cword+1
                  jsr PrintHex
                lda adresse
                cmp #$40
                beq .cont1
                clc
                lda temp
                adc I2Cword
                sta temp
                lda temp+1
                adc I2Cword+1
                sta temp+1
.cont1            inc CurrX
                  inc CurrX
                  plx
                  dex
                 bne .loop02
                 stz CurrX
                 clc
                 lda CurrY
                 adc #6
                 sta CurrY
                 plx
                 dex
                bne .loop01
                LDAY checktxt
                jsr print
                lda temp
                jsr PrintHex
                lda temp+1
                jsr PrintHex
                jmp .loop00
                
hallo           dc.b "TEST-EERPOM : A - clear / B - fill",0
checktxt        dc.b "Checksum:",0

FillEEPROM::    ldx #125
.loop            txa
                 lsr
                 lda #$ff
                 sta eeprom,x
                 lda counter
                 dex
                 lda #$ff
                 sta eeprom,x
                 dex
                bpl .loop
                LDAY eeprom
                jmp WriteSaveGame
****************
PrintHex::      phx
                pha
                lsr
                lsr
                lsr
                lsr
                tax
                lda digits,x
                jsr PrintChar
                pla
                and #$f
                tax
                lda digits,x
                jsr PrintChar
                plx
                rts

***************
digits          db "0123456789ABCDEF"

                

* INCLUDES
                path "..\includes\"
                include "1000Hz.inc"
                include "serial.inc"
                include "debug.inc"
                include "font.inc"
                include "window2.inc"
                include "irq.inc"
                include "font2.hlp"
                include "key.inc"
                include "eeprom.inc"
                include "savegame.inc"

pal             STANDARD_PAL


